module Counter2 where

import Control.Exception
import Control.Concurrent
import Control.Concurrent.STM
import Data.Foldable

update :: TVar Int -> STM ()
update counter =
    do v <- readTVar counter
       writeTVar counter (v+1)

loop n counter = forM_ [1..n] (\_ -> atomically (update counter))

main =
    do counter <- newTVarIO 0
       forkIO (loop 100000 counter)
       loop 100000 counter
       val <- atomically (readTVar counter)
       putStrLn (show val)
